within ProjetTAG.Composants;

model CompressorSimple "Modèle très simple de compresseur à rendement isentropique constant, et à caractéristique (taux de compression/débit) linéaire"
// Les connecteurs : une entrée, une sortie fluides; une entrée, une sortie mécaniques de la librairie standard Modelica
  Connectors.FluidPort inlet annotation(
    Placement(visible = true, transformation(origin = {-90, 58}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-90, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Connectors.FluidPort outlet annotation(
    Placement(visible = true, transformation(origin = {92, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {90, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(
    Placement(visible = true, transformation(origin = {-88, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-90, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_b flange_b annotation(
    Placement(visible = true, transformation(origin = {88, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {90, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
// Les variables
  SI.Angle phi "shaft rotation angle";
  SI.Torque tau "net torque acting on the turbine";
  SI.AngularVelocity omega "shaft angular velocity";
  SI.MassFlowRate qm "Mass flow rate";
  SI.SpecificEnthalpy hin "Inlet enthalpy";
  SI.SpecificEnthalpy hout "Outlet enthalpy";
  SI.Temperature Tin "Inlet temperature";
  SI.Temperature Tout "Outlet temperature";
  SI.Temperature Tis "isentropic Outlet temperature";
  SI.PerUnit PR "Taux de Compression";
// Les paramètres
  parameter SI.PerUnit eta_is = 0.8 "Rendement isentropique";// ici un paramètre (constante dans une simulation)
  
equation
// Lecture des valeurs en entrée fluide
  qm = inlet.m_flow;
  hin = inStream(inlet.h_outflow);
  outlet.h_outflow = hout;
// Mechanical boundary conditions
  flange_a.phi = phi;
  flange_b.phi = phi;
  flange_a.tau + flange_b.tau = tau;
  der(phi) = omega;
//Reverse flow equation : ask the teacher for explanations
  inlet.h_outflow = inStream(outlet.h_outflow);
//Pressure ratio definition
  PR = outlet.p / inlet.p;
// --------------------------------------- //
//            DEBUT PARTIE A COMPLETER     //  
// --------------------------------------- //
  
//Relation entre enthalpie et température pour gaz parfait
  //Tin = ???;
  //Tout = ???;

//Energy balance equation : premier principe système ouvert
  // ??? = ???;
  
//Mass balance equation : conservation masse système ouvert
  // ??? = 0;
  
//Isentropic efficiency definition : se renseigner sur les compresseurs
  //eta_is = ???;
  
//Isentropic temperature as a function of the pressure rate : se renseigner sur les compresseurs
  //Tis = ???;

// --------------------------------------- //
//            FIN   PARTIE A COMPLETER     //  
// --------------------------------------- //
  
// Caractéristique du compresseur:
  PR=100*qm;
  // Toute simple, indépendante de la vitesse de rotation
  // Le taux de compression est proportionnel au débit massique
  annotation(
    Icon(graphics = {Polygon(points = {{-80, 80}, {-80, -80}, {80, -40}, {80, 40}, {-80, 80}}), Text(origin = {8, -8}, extent = {{-70, 34}, {70, -34}}, textString = "Compresseur Basique")}));
annotation (Documentation(info="<html>
<p> <i>Il y a des trous à compléter : les ???. Votre travail consiste à compléter ces lignes.</i> </p>
<p> On utilise un modèle de gaz parfait avec cp=cte, gamma=cte, déjà déclarés dans le package.</p>
</html>"));
end CompressorSimple;